package com.blazinggames.ld25
{
	import com.blazinggames.gamejam.data.TileMap;
	import com.blazinggames.gamejam.layers.starling.WorldSprite;
	import com.blazinggames.ld25.res.ResMan;
	
	import starling.display.Image;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	
	public class Deer extends WorldSprite
	{
		private static const TILES_PER_INTERVAL:Number = 0.1;
		
		private var _turnRight:Boolean;
		private static var _textures:Vector.<Texture>;
		private var _image:Image;
		
		public function Deer()
		{
			super(0);
			if (_textures == null) {
				var atlas:TextureAtlas = ResMan.getSprites();
				_textures = atlas.getTextures("reindeer");
			}
			_image = new Image(_textures[0]);
			_image.x = -24;
			_image.y = -20;
			addChild(_image);

			_turnRight = false;
		}
		
		public function handleMovement(gnome:Gnome, manager:CorralScreen):Boolean
		{
			var dist:Number = WorldSprite.findDistanceSquared(gnome.worldX, gnome.worldY, worldX, worldY);
			if (dist < 16) {
				var ang:Number = WorldSprite.findSpriteAngle(this, gnome);
				var targetX:Number = worldX;
				targetX -= (Math.cos(ang) * TILES_PER_INTERVAL);
				var targetY:Number = worldY;
				targetY -= (Math.sin(ang) * TILES_PER_INTERVAL);
				if (manager.canEnterTile(targetX, targetY, this) == false) {
					ang -= (Math.PI / 2);
					targetX = worldX - (Math.cos(ang) * TILES_PER_INTERVAL);
					targetY = worldY - (Math.sin(ang) * TILES_PER_INTERVAL);
					if ((_turnRight) || (manager.canEnterTile(targetX, targetY, this) == false) ) {
						ang += Math.PI;
						targetX = worldX - (Math.cos(ang) * TILES_PER_INTERVAL);
						targetY = worldY - (Math.sin(ang) * TILES_PER_INTERVAL);
						_turnRight = true;
						if (manager.canEnterTile(targetX, targetY, this) == false) {
							targetX = worldX;
							targetY = worldY;
							_turnRight = false;

						}
					}
				} else
					_turnRight = false;

				worldX = targetX;
				worldY = targetY;
				if (manager.isExit(targetX, targetY))
					return false;
			} else if (dist > 64) {
				// idle action here such as grazing and random walk
			}
			return true;
		}
	}
}