package com.blazinggames.ld25
{
	import com.blazinggames.gamejam.layers.starling.WorldSprite;
	import com.blazinggames.ld25.res.ResMan;
	
	import starling.display.Image;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	
	public class Gnome extends WorldSprite
	{
		public static const NORTH:int = 1;
		public static const EAST:int = 2;
		public static const SOUTH:int = 4;
		public static const WEST:int = 8;
		
		private var _direction:int;
		private var _textures:Vector.<Texture>;
		private var _image:Image;
		private var _frame:int, _frameDelay:int;
		private var _soundCount:int;
		
		public function Gnome()
		{
			super(0);
			var atlas:TextureAtlas = ResMan.getSprites();
			_textures = atlas.getTextures("gnome");
			_image = new Image(_textures[0]);
			_image.x = -16;
			_image.y = -16;
			addChild(_image);
			_frameDelay = 0;
			_frame = 0;
		}
		
		public function setDirection(dir:int, moving:Boolean):void
		{
			if (moving) {
				_direction |= dir;
			} else {
				var mask:int = dir ^ 0xFFFFFFFF;
				_direction &= mask;
			}
		}
		
		public function isMoving(dir:int):Boolean
		{
			return ((_direction & dir) > 0);
		}
		
		public function update():void
		{
			++_frameDelay;
			if ((_direction) && (_frameDelay > 2)) {
				_frameDelay = 0;
				++_frame;
				if (_frame >= _textures.length)
					_frame = 0;
				_image.texture = _textures[_frame];
			}
			// WalkSound
			++_soundCount;
			if ((_direction) && (_soundCount > 50)) {
				_soundCount = 0;
				ResMan.playSound("WalkSound");
			}
		}
	}
}