package com.blazinggames.ld25
{
	import com.blazinggames.gamejam.layers.starling.ScreenManager;
	import com.blazinggames.ld25.res.ResMan;
	
	import starling.textures.TextureAtlas;
	
	public class LD25Manager extends ScreenManager
	{
		protected var _game:CorralScreen;
		
		public function LD25Manager()
		{
			super();
			registerScreen("Title", new TitleScreen(this), true);
			_game = new CorralScreen(this, null);
			registerScreen("Corral", _game);
			var slides:TextureAtlas = ResMan.getSlides();
			registerScreen("About", new SlideshowScreen(this, slides.getTextures("About")));
			registerScreen("Instructions", new SlideshowScreen(this, slides.getTextures("Instructions")));
		}
		
		override protected function clearState(oldState:int):void
		{
			hideOverlay();
		}
		
		override protected function startState(newState:int):void
		{
			switch (newState) {
				case GAMESTATE_GAME_OVER:
					popScreen();
					break;
				case GAMESTATE_PLAYING:
					_game.generateCorral(50);
					pushScreen("Corral");
					break;
			}
		}
	}
}