package com.blazinggames.ld25
{
	import com.blazinggames.gamejam.layers.starling.IScreen;
	import com.blazinggames.gamejam.layers.starling.ScreenManager;
	
	import flash.ui.Keyboard;
	
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.textures.Texture;
	
	public class SlideshowScreen extends Sprite implements IScreen
	{
		private var _screenManager:ScreenManager;
		private var _slides:Vector.<Texture>;
		private var _swapWhenDone:String;
		private var _image:Image;
		private var _frame:int;
		
		public function SlideshowScreen(manager:ScreenManager, slides:Vector.<Texture>, scale:Number = 2,swapWhenDone:String = null)
		{
			super();
			_screenManager = manager;
			_slides = slides;
			_swapWhenDone = swapWhenDone;
			_image = new Image(_slides[0]);
			_image.scaleX = scale;
			_image.scaleY = scale;
			addChild(_image);
			_frame = 0;
		}
		
		public function reset(screenManager:ScreenManager, params:Object):void
		{
			_frame = 0;
		}
		
		public function handleTouch(touchX:int, touchY:int, touchtype:int):void
		{
			if (touchtype == ScreenManager.TOUCHTYPE_ENDED)
				nextFrame();
		}
		
		public function handleKeyboard(keycode:int, isDown:Boolean, flags:uint):void
		{
			if ((isDown == false) && (keycode == Keyboard.ENTER))
				nextFrame();
		}
		
		public function update(params:Object=null):void
		{
		}
		
		public function nextFrame():void
		{
			++_frame;
			if (_frame >= _slides.length) {
				_frame = 0;
				if (_swapWhenDone != null)
					_screenManager.swapScreen(_swapWhenDone);
				else
					_screenManager.popScreen();
			}
			_image.texture = _slides[_frame];
		}
	}
}