package com.blazinggames.ld25
{
	import com.blazinggames.gamejam.layers.starling.IScreen;
	import com.blazinggames.gamejam.layers.starling.ScreenManager;
	import com.blazinggames.gamejam.ui.starling.Slider;
	import com.blazinggames.ld25.res.ResMan;
	
	import flash.geom.Point;
	import flash.media.SoundMixer;
	import flash.media.SoundTransform;
	
	import starling.display.Button;
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.text.TextField;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	
	public class TitleScreen extends Sprite implements IScreen
	{
		private var _screenManager:ScreenManager;
		private var _volume:Slider;
		
		public function TitleScreen(manager:ScreenManager)
		{
			super();
			_screenManager = manager;
			var slides:TextureAtlas = ResMan.getSlides();
			var backdrop:Image = new Image(slides.getTexture("Title0000"));
			backdrop.scaleX = 2;
			backdrop.scaleY = 2;
			addChild(backdrop);
//			var title:TextField = new TextField(490,200,"Evil Gnome's Revenge", "_serif", 80, 0xFFFF0000, true);
//			addChild(title);
			var texture:Texture = Texture.fromColor(150,50,0xFF000088);
			var aboutButton:Button = new Button(texture, "About");
			aboutButton.x = 490;
			aboutButton.y = 20;
			aboutButton.addEventListener(Event.TRIGGERED, handleAbout);
			addChild(aboutButton);
			var instructionButton:Button = new Button(texture, "Instructions");
			instructionButton.x = 490;
			instructionButton.y = 80;
			instructionButton.addEventListener(Event.TRIGGERED, handleInstructions);
			addChild(instructionButton);
			var playButton:Button = new Button(texture, "Play");
			playButton.x = 490;
			playButton.y = 140;
			playButton.addEventListener(Event.TRIGGERED, handlePlay);
			addChild(playButton);
			
			_volume = new Slider(Texture.fromColor(150,20,0xFF444444), Texture.fromColor(8,20), new Point(0,0), new Point(142,0));
			addChild(_volume);
			_volume.x = 480;
			_volume.y = 210;
			_volume.addEventListener(Slider.VALUE_CHANGED_EVENT, hanldeSoundVolume);
			SoundMixer.soundTransform = new SoundTransform(_volume.value);
			var volumeLabel:TextField = new TextField(150,50,"Volume", "_serif", 20, 0xFFFFFF00, true);
			volumeLabel.x = 480;
			volumeLabel.y = 225;
			addChild(volumeLabel);
		}

		private function hanldeSoundVolume():void
		{
			SoundMixer.soundTransform = new SoundTransform(_volume.value);
			ResMan.playSound("ExitSound");
		}

		private function handlePlay(evt:Event):void
		{
			_screenManager.changeGameState(ScreenManager.GAMESTATE_PLAYING);
		}
		
		private function handleInstructions(evt:Event):void
		{
			_screenManager.pushScreen("Instructions");
		}
		
		private function handleAbout(evt:Event):void
		{
			_screenManager.pushScreen("About");
		}
		
		public function reset(screenManager:ScreenManager, params:Object):void
		{
		}
		
		public function handleTouch(touchX:int, touchY:int, touchtype:int):void
		{
		}
		
		public function handleKeyboard(keycode:int, isDown:Boolean, flags:uint):void
		{
		}
		
		public function update(params:Object=null):void
		{
		}
	}
}