package com.blazinggames.ld25.res
{
	import flash.display.Bitmap;
	import flash.media.Sound;
	import flash.utils.Dictionary;
	
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;

	public class ResMan
	{
		[Embed(source="VillainDeerExit.mp3")]
		public static const ExitSound:Class;
		[Embed(source="VillainWalk.mp3")]
		public static const WalkSound:Class;
		[Embed(source="VillainTimeUp.mp3")]
		public static const TimeUpSound:Class;
		
		
		[Embed(source="Slides.png")]
		public static const SlidesTexture:Class;		
		[Embed(source="Slides.xml", mimeType="application/octet-stream")]
		public static const SlidesXML:Class;

		[Embed(source="Sprites.png")]
		public static const SpritesTexture:Class;		
		[Embed(source="Sprites.xml", mimeType="application/octet-stream")]
		public static const SpritesXML:Class;

		[Embed(source="corral.png")]
		public static const TilesetTexture:Class;		
		[Embed(source="corral.xml", mimeType="application/octet-stream")]
		public static const TilesetXML:Class;

		private static var gameTextures:Dictionary = new Dictionary();
		private static var tilesetTextureAtlas:TextureAtlas;
		private static var slidesTextureAtlas:TextureAtlas;
		private static var spritesTextureAtlas:TextureAtlas;
		private static var gameSounds:Dictionary = new Dictionary();
		
		public function ResMan()
		{
		}

		public static function getSound(name:String):Sound
		{
			if (gameSounds[name] == undefined)
			{
				var sound:Sound = new ResMan[name]();
				gameSounds[name] = sound;
			}
			return gameSounds[name];
		}

		public static function playSound(name:String):void
		{
			if (gameSounds[name] == undefined)
			{
				var sound:Sound = new ResMan[name]();
				gameSounds[name] = sound;
			}
			gameSounds[name].play();
		}

		public static function getTexture(name:String):Texture
		{
			if (gameTextures[name] == undefined)
			{
				var bitmap:Bitmap = new ResMan[name]();
				gameTextures[name] = Texture.fromBitmap(bitmap);
			}
			return gameTextures[name];
		}

		public static function getTileset():TextureAtlas
		{
			if (tilesetTextureAtlas == null)
			{
				var texture:Texture = getTexture("TilesetTexture");
				var xml:XML = XML(new TilesetXML());
				tilesetTextureAtlas = new TextureAtlas(texture, xml);
			}
			return tilesetTextureAtlas;
		}

		public static function getSlides():TextureAtlas
		{
			if (slidesTextureAtlas == null)
			{
				var texture:Texture = getTexture("SlidesTexture");
				var xml:XML = XML(new SlidesXML());
				slidesTextureAtlas = new TextureAtlas(texture, xml);
			}
			return slidesTextureAtlas;
		}

		public static function getSprites():TextureAtlas
		{
			if (spritesTextureAtlas == null)
			{
				var texture:Texture = getTexture("SpritesTexture");
				var xml:XML = XML(new SpritesXML());
				spritesTextureAtlas = new TextureAtlas(texture, xml);
			}
			return spritesTextureAtlas;
		}
	}
}